function [beta,Fmtot] = MF2(Lm, w, Eta, L1,EA)
%MOORFORCE calculates the force of Mooring Line
%beta is the angle between mooring line direction and heading of Platform,
%U1 ----sway motion
%U2----Yaw motion
%Fx Fy, wind Force in X and Y direction. global coordinate
%Lm---Mooring line Length
%d----Distance between turbine and moored point
% %   Detailed explanation goes here
x = Eta(1);%Surge motion
y = Eta(2);%Sway motion
fi = Eta(3);%Yaw motion
u = Eta(4);%Surge velocity
v = Eta(5);%Sway velocity
r = Eta(6);%Yaw angular velocity


Fmtot0 = 1000;
%% elastic
a = (y-L1*sin(fi));%y dist from anchor to fairlead
b = (Lm+L1+x-L1*cos(fi));%x dist from anchor to fairlead
beta = atan(a/b);
dist = sqrt(a^2+b^2);%distance between anchor posi to fairlead
Fmtot = dist/(Lm/EA+2*1/w*asinh(w*Lm/2/Fmtot0));
while abs (Fmtot0 - Fmtot)>1
    Fmtot0 = Fmtot;
    Fmtot = dist/(Lm/EA+2*1/w*asinh(w*Lm/2/Fmtot0));
end
if b<0
    if a>0
        beta = -atan(a/b)+pi/2;
    else
        beta = -atan(b/a)-pi/2;
    end
end
    
% if sqrt(a^2+b^2)<Lm
%     Fmtot = 0;
% else
%     Fmtot = (sqrt(a^2+b^2)-Lm)*EA;
% end

%% inelastic

end