clearvars -except PlatMotions time_SIMO; clc

%% Read Aerodynamic Force
global Aerof
file=['OprturAerod.dat'];
Aerof = importdata(file);

%% Local aerodynamic force
alpha = Aerof(:,1);


flx = Aerof(:,2);%Force on x' dir
fly = Aerof(:,3);%AeroForce on y' dir
mom = Aerof(:,4);%AeroForce on y' dir

%% Restoring force
% l1 = 25;
% for i = 1:length(alpha)
%     fgx(i) = flx(length(alpha)+1-i)*cosd(alpha(i))+fly(length(alpha)+1-i)*cosd(alpha(i)+90);
%     fgy(i) = fly(length(alpha)+1-i)*cosd(alpha(i))+flx(length(alpha)+1-i)*sind(alpha(i));
%     M_res(i) = l1*cosd(alpha(i))*fgy(i)-l1*(136+fgx(i))*sind(alpha(i));%+mom(length(alpha)+1-i); %Yaw restoring force wrp to yaw
% end
% figure
% plot(alpha,M_res)
% grid on
% 
% figure
% plot(alpha, flx)
% title('Aerodyn Force Global x dir')
% grid on
% figure
% plot(-alpha, fly)
% title('Aerodyn Force global y')
% grid on
% figure
% plot(-alpha, M_res)
% title('Aerodyn mom')
% grid on
%%

rho = 1025;
L = 50;%barge length m
B = 50;%barge width m
T = 10;%barge height m
D = 7; %Draught m
V = L*B*D;%Volume m3
g = 9.807;%gravity constant
Mass = rho*V;%Total Mass kg
L1 = 100;% Fair Length
Lm = 200;%Mooring line Length m
EA = 3.8424e+8; %Mooring line stiffness
K = 1*[2.2e6 0 0; 0 3.6e3 0; 0 0 (6e5-5.9e4)];%Linearized restoring force
% Bu = [1.0368E-6 -2.7187E-12; 4.6443E-12 3.1178E-13];%Undimensional damping matrix
% Au = [6.4613E-1 -2.3931E-9; -1.4048E-8 8.2556E-3];%Undimensional Added mass matrix
% 
% Bd = [rho*V*sqrt(g/L) rho*V*sqrt(g*L); rho*V*sqrt(g*L) rho*V*L*sqrt(g*L)];%dimensional damping matrix coef
% Ad = [rho*V rho*V*L; rho*V*L rho*V*L*L];%Undimensional added-mass coef
M = diag([1.79375E+07 1.79375E+07 2.8027e+09]);
A = diag([3.1559e-1*0.1025E+04*0.1750E+05;3.1559e-1*0.1025E+04*0.1750E+05;7.4772E-3*0.1025E+04*0.1750E+05*100*100]);
B = 0.1*2*sqrt((M+A).*abs(K));%%damping matrix2*sqrt((M+A).*abs(K))*0.5%diag([1.2385E-07*rho*sqrt(g/L) 1.2378E-07*rho*sqrt(g/L) 4.4094E-12*rho*sqrt(g*L)*V]);

w=1550; %Mooring line weight
% B = Bu.*Bd;
% A = Au.*Ad;%added-mass matrix
% M = Mu.*Ad;
% M(2,2) = M(2,2)+L1^2*Mass;

K=0*K;

Eta = [0;0;0*pi/180;0;0;0];

dt = 0.1;
tspan = 0:dt:2000; 
[t,Etap] = ode45(@(t,Eta) OEOM(t,Eta,Lm,L1,M,A,B, EA,K, w), tspan, Eta);

% dist = sqrt((Etap(:,2)-L1*sin(Etap(:,3))).^2+(Lm+L1+Etap(:,1)-L1*cos(Etap(:,3))).^2);%distance between anchor posi to fairlead
% RO*VOL*SQRT(G/L)   RO*VOL*SQRT(G*L)   RO*VOL*L*SQRT(G*L)
% for iter = 1:length(tspan)
%     [beta(iter), Fmtot(iter)] = MF2(Lm, w, Etap(iter,:), L1, EA);
%     [Fx(iter),Fy(iter),Fxl(iter),Fyl(iter),AerMom(iter)] = OprWindForce(Etap(iter,:));
% end

figure(1)
plot(t,Etap(:,1))
xlabel('time[s]')
ylabel('Motions')
grid on
hold on
plot(t,Etap(:,2))
plot(t,Etap(:,3)/pi*180)
% plot(time_SIMO, PlatMotions(:,1))
legend('Surge','SwaySurge','Yaw')
title('10% C_c_r_i')
% 
% for i =1:length(t)
%     if yaw(i)>150
%         yaw(i)=yaw(i)-360;
%     end
% end
% 
% plot(t,surge,t,sway,t,yaw)
% xlabel('time[s]')
% ylabel('Motions')
% % grid on
% % plot(time_SIMO, PlatMotions(:,1))
% legend('Surge[m]','Sway[m]','Yaw[deg]')
% 
% 
% plot(xaxis,X1,xaxis,X2)
% xlabel('time[s]')
% ylabel('Forth-after force in shaft system[N]')
% legend('Initial','Improved')
% xlim([0 4000])
% grid on
% 
% 
% 
% plot(xaxis,Y1,xaxis,Y2)
% xlabel('time[s]')
% ylabel('Side to side force in shaft system[N]')
% legend('Initial','Improved')
% xlim([0 4000])
% grid on
% 
% 
% plot(xaxis,Z1,xaxis,Z2)
% xlabel('time[s]')
% ylabel('Torsion about z axis in shaft system[N]')
% legend('Initial','Improved')
% xlim([0 4000])
% grid on
% figure(2)
% plot(2*t,Etap(:,3)/pi*180)
% xlabel('time[s]')
% ylabel('Yaw Motion[deg]')
% grid on
% hold on
% plot(time_SIMO, PlatMotions(:,6))
% legend('linearized model','sima model')
% 
% 
% figure(3)
% plot(2*t,Etap(:,2))
% xlabel('time[s]')
% ylabel('Sway Motion[m]')
% grid on
% hold on
% plot(time_SIMO, PlatMotions(:,2))
% legend('linearized model','sima model')
% % % 
% % figure(4)
% % plot(t,AerMom+Fyl*L1,'linewidth',2)
% % xlabel('time[s]')
% % ylabel('Fx[N]')
% % grid on
% 
% figure(5)
% plot(Etap(:,2),Etap(:,1),'linewidth',2)
% xlabel('Sway[m]')
% ylabel('Surge[m]')
% grid on
% hold on
% plot(0,-Lm-L1,'rx','linewidth',2)
% set(gca,'YDir','reverse')


%%
% alpha = flipud(Aerof(:,1));
% 
% 
% flx = flipud(Aerof(:,2));%Force on x' dir
% fly = flipud(Aerof(:,3));%AeroForce on y' dir
% fx = (flx.*cosd(alpha)-fly.*sind(alpha));
% plot(alpha,fx)