function [Fx,Fy,Fxl,Fyl,Moma] = OprWindForce(Eta)
%WINDFORCE Calculate the windforce Projected to x and y direction in global
%coordinate
%   Fx aeroforce in X-dir
%   Fy aeroforce in Y-dir
%   U position vector, U(1): Sway displacement
%   U(2) Yaw angle
%   alpha angle between centre line and mooring line direction
global Aerof
fi = Eta(3)/pi*180;
alpha = flipud(Aerof(:,1));


flx = flipud(Aerof(:,2));%Force on x' dir
fly = flipud(Aerof(:,3));%AeroForce on y' dir
mom = flipud(Aerof(:,4));%AeroForce on y' dir


left = floor(fi/3)+28;% number of elem. on the left side of yaw angle
right = floor(fi/3)+29;%... right side of yaw angle

Fxl = 1e3*(flx(left)+mod(fi,3)/3*(flx(right)-flx(right)));%Linear approximation to find force on X'-dir
Fyl = 1e3*(fly(right)+mod(fi,3)/3*(fly(right)-fly(left)));%Linear approximation to find force on Y'-dir
Moma = 1e3*(mom(left)+mod(fi,3)/3*(mom(right)-mom(left)));

%Global Forces
Fy = (Fyl*cosd(fi)+Fxl*sind(fi));
Fx = (Fxl*cosd(fi)-Fyl*sind(fi));
