clear all;clc;

global Aerof
file = ['E:\MASTER\NTNU\ThesisWork\FixedTurbine\Codes\FixturAerod.dat'];
Aerof = importdata(file);

%% Local aerodynamic force
alpha = Aerof(:,1);


flx = Aerof(:,2);%Force on x' dir
fly = Aerof(:,3);%AeroForce on y' dir
mom = Aerof(:,4);%AeroForce on y' dir

rho = 1025;
L = 50;%barge length m
B = 50;%barge width m
T = 10;%barge height m
D = 7; %Draught m
V = L*B*D;%Volume m3
g = 9.807;%gravity constant
Mass = rho*V;%Total Mass kg
L1 = 75;% Fair Length
Lm = 175;%Mooring line Length m
EA = 3.8424e+8/Lm; %Mooring line stiffness
K = [0 0 3E3; 0 0 -17.43E3; 3E3 -17.43E3 526.1E3];%Linearized restoring force

M = diag([1.79375E+07 1.79375E+07 2.8027e+09]);
A = diag([3.1559e-1*0.1025E+04*0.1750E+05;3.1559e-1*0.1025E+04*0.1750E+05;7.4772E-3*0.1025E+04*0.1750E+05*100*100]);
B = 0.1*diag([32051 20128 3.506e+06]);%2*sqrt((M+A).*abs(K))*0.1;%damping matrix

% B = Bu.*Bd;
% A = Au.*Ad;%added-mass matrix
% M = Mu.*Ad;
% M(2,2) = M(2,2)+L1^2*Mass;
for i = 1:179
    alfa(i) = i-90;
    Eta = [-70;0;alfa(i)/180*pi;0;0;0];
    x = Eta(1);%Surge motion
    y = Eta(2);%Sway motion
    fi = Eta(3);%Yaw motion
    u = Eta(4);%Surge velocity
    v = Eta(5);%Sway velocity
    r = Eta(6);%Yaw angular velocity
    [Fx(i),Fy(i),Fxl,Fyl,AerMom(i)] = WindForce(Eta);
    [beta,Fxm(i),Fym(i)] = MF1(Lm, Eta, L1, EA);
    Mom_Right(i) = Fxm(i)*L1*sin(fi)-Fym(i)*L1*cos(fi);%Fy*L1*cos(fi)-Fx*L1*sin(fi);%Righting Force Provided by Fair
end
    F_ext = [Fx+Fxm ;Fy+Fym; AerMom+Mom_Right];
    %plot(alfa,F_ext(1,:))
%     K_surge=F_ext(1,90:150)
%     K_sway = F_ext(2,70:110)
%     K_yaw = F_ext(3,70:100)
%     plot(alfa, AerMom)
%     XXX = 1:length(K_yaw)
%     
    % Linearised surge: 50000N+3991*alpha/\
    % Linearised sway-yaw: 4e5-2.255e4*alpha 20deg
    % Linearised yaw-yaw: 14e5-5.9e4*(alpha+20deg),/\(6e5-)
%     K = [EA 0 3991; 0 3.58E4  -2.255e4; 3991 -2.255e4 5.9e4];6e5-
K = [4400 0 0; 0 3.6e3 0; 0 0 5.9e4];

    2*pi./sqrt(eig(K,M+A))
